import re

from openai import AzureOpenAI
import time
import constants

# Set up OpenAI API configuration

def RemoveCodeMarkersFromLLMResponse(response):
    # Remove lines starting with \n``` or ```
    cleaned_response = re.sub(r'\n```.*|```.*', '', response)
    return cleaned_response

    messages = [{"role": "user", "content": prompt}]        
    
    if not silent:
        print(f"Starting Azure OpenAI Call, prompt length (chars): {len(str(messages))}")
    
    start = time.time()

    # Setting up the deployment name
    client = AzureOpenAI(
        api_key=constants.api_key,  
        api_version=constants.api_version,
        azure_endpoint = constants.azure_endpoint,
        timeout = 10000,
        max_retries = 3,
    )
                

    completion = client.chat.completions.create(
        model=constants.model, 
        temperature=temperature,
        messages=messages,
        max_tokens=4096,    
        top_p=top_p,
        frequency_penalty=0,
        presence_penalty=0,
    )

    response = completion.choices[0].message.content

    end = time.time()

    if not silent:
        print(f"Finished Azure OpenAI Call, duration: {str(end - start)}, response length (chars):{len(str(response))}")
    return response

def CallAzureOpenAI4(prompt, temperature = 0.7, silent = False, top_p = .95):

    # truncate the prompt if it is too long
    token_limit = 80000 # 1 token = 4 characters
    if (len(prompt) > token_limit * 4):        
        prompt = prompt[:token_limit * 4]
        print(f"Truncated prompt to length: {len(prompt)}")

    messages = [{"role": "user", "content": prompt}]        
    
    if not silent:
        print(f"Starting Azure OpenAI Call, prompt length (chars): {len(str(messages))}")
    
    start = time.time()

    # Setting up the deployment name
    client = AzureOpenAI(
        api_key=constants.api_key,  
        api_version=constants.api_version,
        azure_endpoint = constants.azure_endpoint,
        timeout = 10000,
        max_retries = 3,
    )
                

    completion = client.chat.completions.create(
        model=constants.model, 
        temperature=temperature,
        messages=messages,
        max_tokens=4096,    
        top_p=top_p,
        frequency_penalty=0,
        presence_penalty=0,
    )

    response = str(completion.choices[0].message.content)

    response = response.replace("```json","").replace("\n```","")

    end = time.time()

    if not silent:
        print(f"Finished Azure OpenAI Call, duration: {str(end - start)}, response length (chars):{len(str(response))}")
    return response

